#!/usr/bin/env node
var fs = require('fs'),
	currentDir = process.cwd(),
	args = process.argv.slice(2),
	exec = require('child_process').exec;
	
var usage = [
	'',
	' Usage: package [options]',
	'',
	' Options: ',
	'	-h, --help		Show this help.',
	'	-v, --version	Show version.',
	''
].join("\n");

function dirname(path) {
    return path.replace(/\\/g,'/').replace(/\/[^\/]*$/, '');;
}

switch(args[0]) {
	case '-h':
	case '--help':
		console.log(usage);
		break;
	case '-v':
	case '--version':
		console.log('0.0.1');
		break;
	default:
		var packagesNumber = 0;
		var json = {
			name : dirname(currentDir),
			description : '',
			version : '0.0.1',
			keywords: [],
			author: 'Steve Appleseed',
			dependencies: {},
			main : '',
			engines: {
				'node' : '0.4.x'
			}
		}
		
		global.name = function(name) {
			json.name = name;
		}
		
		global.desc = function(desc) {
			json.description = desc;
		}
		
		global.version = function(version) {
			json.version = version;
		}
		
		global.keywords = function(keywords) {
			json.keywords = keywords;
		}
		
		global.author = function(name) {
			json.author = name;
		}
		
		global.node = function(version) {
			json.engines['node'] = version;
		}
		
		global.main = function(file) {
			json.main = file;
		}
		
		global.package = function(name, version) {
			if(name) {
				packagesNumber++;
				var cmd = !version ? 'npm install ' + name : 'npm install ' + name + '@' + version;
				if(!version) {
					version = '*';
				}
				json.dependencies[name] = version;
				exec('cd ' + currentDir + ' && ' + cmd, function(err, stdout, stderr){
					if(stderr.indexOf("404") > 0) {
						console.log('\033[31m' + '[x]' + '\033[39m' + ' ' + name + ' not found in NPM registry.');
					} else {
						console.log('\033[32m' + '[x]' + '\033[39m' + ' ' + name + ' installed.');
					}
					fs.unlink(currentDir + '/npm-debug.log', function(){});
					packagesNumber--;
					if(packagesNumber == 0) {
						fs.writeFile(currentDir + '/package.json', JSON.stringify(json), 'utf8', function(){
							console.log('Done.');
						});
					}
				});
			}
		}
		
		exec('cd ' + currentDir + ' && coffee -c -b Npmfile', function(){
			console.log('Installing packages from Npmfile at ' + currentDir + '/Npmfile');
			console.log('');
			require(currentDir + '/Npmfile.js');
			fs.unlink(currentDir + '/Npmfile.js', function(){});
		});
}